--makes all entities of type beaver_species slowly collect trees around themselfs

local beaver_species   = 'wooden-chest' --this entity is a beaver (needs an inventory)
local beaver_max_range = 24   --in tiles
local beaver_interval  = 5*60 --in ticks

local function unleash_the_beavers(e)
  -- feeds each beaver one tree per interval
  -- print('There are ' .. #global.beavers .. ' beavers alive.')
  for b,beaver in pairs(global.beavers) do
    if not beaver.specimen.valid then
      table.remove(global.beavers,b)
    else
      local territory = {
        {beaver.specimen.position.x-beaver.range,beaver.specimen.position.y-beaver.range},
        {beaver.specimen.position.x+beaver.range,beaver.specimen.position.y+beaver.range}}
      local tree = beaver.specimen.surface.find_entities_filtered{type='tree',limit=1,area=territory}[1]
      if not tree then
        if beaver.range >= beaver_max_range then
          table.remove(global.beavers,b)
        else
          beaver.range = beaver.range + 1
          end
      else
        --can trees actually have more than one type of product?
        local twigs = tree.prototype.mineable_properties.products
        local eaten = 0
        for _,twig in pairs(twigs) do
          beaver.specimen.insert{name=twig.name,count=twig.amount}
          eaten = eaten + 1
          end
        --tree dies only if all twigs fit into the beaver
        --this coult be exploited to gain infinite resources from a single tree
        if #twigs == eaten then tree.die() end
        end
      end
    end
  if #global.beavers == 0 then
    --no more active beavers, get rid of the handler
    global.beavers = nil
    script.on_nth_tick(beaver_interval,nil)
    end
  end

local function prepare_the_beavers()
  if global.beavers then
    script.on_nth_tick(beaver_interval,unleash_the_beavers)
    end
  end

script.on_load(prepare_the_beavers)
script.on_init(prepare_the_beavers)
script.on_configuration_changed(prepare_the_beavers)

script.on_event(
  {defines.events.on_built_entity,
   defines.events.on_robot_built_entity},
  function(e)
    if not e.created_entity.name == beaver_species then return end
    -- print('I saw a beaver!')
    if not global.beavers then global.beavers = {} end
    global.beavers[#global.beavers+1] = {specimen = e.created_entity, range = 5}
    prepare_the_beavers()
    end)  
    